services:
  - docker:dind


dockerize:
  stage: deploy
  image: gitlab/dind:latest
  variables:
    IMAGEAPP: $CI_REGISTRY_IMAGE/app:$CI_COMMIT_REF_NAME
    IMAGETEST: $CI_REGISTRY_IMAGE/test:$CI_COMMIT_REF_NAME

  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $IMAGEAPP ./app
    - docker build -t $IMAGETEST ./test
    - docker push $IMAGEAPP
    - docker push $IMAGETEST
    
    
test:
  stage: test
  image: docker:latest
  before_script:
    - apk add --no-cache py-pip      # <--
    - pip install docker-compose  
    - docker-compose -f docker-compose.yml pull
    - docker-compose -f docker-compose.yml up -d
  script:
    - docker-compose -f docker-compose.yml run test test --rm
    - docker-compose -f docker-compose.yml run test4 test4 --rm
    - docker-compose -f docker-compose.yml run test15 test15 --rm
    - docker-compose -f docker-compose.yml run test2 test2 --rm
    - docker-compose -f docker-compose.yml run test3 test3 --rm
    - docker-compose -f docker-compose.yml run test5 test5 --rm